'use strict';

var extend = require('deep-extend');
var ejs = require('ejs'); 
var yeoman = require('yeoman-generator');
var child_process = require('child_process');

exports.copyfileCmtTpl = function (fs, src, dst, template, cmtType = "//", isAbove = true) {
    var comment = cmtType + " ";

    fs.copy(src, dst, {
        process: function(contents, filename) {
            contents = contents.toString();
            for (var obj in template) {
                contents = contents.replace(comment + obj, 
                    isAbove ? template[obj] + "\n" + comment + obj : comment + obj + "\n" + template[obj]);
            }
            return contents;
        }
    });
}


exports.execCmd = function(cmd) {
    return new Promise((resolve, reject) => {
        child_process.exec(cmd, {}, (err, stdout, stderr) => {
            console.log(stdout, stderr);
            if(err) {
                return reject(err);
            } else {
                return resolve(stdout);
            }
        });
    });
}